package hero.client.grapheditor;

/**
 * WFNewProjectWindow.java
 *
 *
 * Created: Mon Aug 12 12:02:44 2002
 *
 * @version 1.0
 */

import java.awt.*;
import java.util.*;
import hero.net.ProjectSession.StrutsNodeValue;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import java.text.SimpleDateFormat;
import javax.swing.JCheckBox;

public class WFWindowManager {

	WFManager manager;
	WFPersistence persistence;

	public String newProjectWindow() {
		String projectName;
		try {
			projectName =
				JOptionPane.showInputDialog(
					null,
					"BnProject Name: ",
					"New project",
					JOptionPane.INFORMATION_MESSAGE);
			while (projectName != null && projectName.equals("")) {
				JOptionPane.showMessageDialog(
					null,
					"Please enter project name");
				projectName =
					JOptionPane.showInputDialog(
						null,
						"BnProject Name: ",
						"New BnProject",
						JOptionPane.INFORMATION_MESSAGE);
			}
			if (projectName != null) {
				boolean ok = persistence.createProject(projectName);
				if (!ok) {
					JOptionPane.showMessageDialog(
						null,
						"BnProject already exist or not user permission... ");

				} else {
					manager.setTitle(projectName);
					return projectName;
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(
				null,
				"System Error in create project");
		}
		return null;
	}

	public WFWindowManager(WFManager manager, WFPersistence persistence) {
		this.manager = manager;
		this.persistence = persistence;
	}

	public boolean cloneProjectWindow() {
		try {
			JPanel jp = new JPanel();
			Object[] possibleValues = persistence.getProjects();
			JComboBox projectNames = new JComboBox(possibleValues);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel("Choose BnProject ", SwingConstants.LEFT));
			jp.add(projectNames);

			JTextField newProject = new JTextField("", 0);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel("BnProject Name ", SwingConstants.LEFT));
			jp.add(newProject);

			int cloneOption =
				JOptionPane.showConfirmDialog(
					null,
					jp,
					"Clone BnProject",
					JOptionPane.OK_CANCEL_OPTION);
			if (cloneOption != JOptionPane.CANCEL_OPTION) {
				while ((newProject.getText()).equals("")
					&& cloneOption != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(
						null,
						"Please enter project name... ");
					cloneOption =
						JOptionPane.showConfirmDialog(
							null,
							jp,
							"Clone BnProject",
							JOptionPane.OK_CANCEL_OPTION);
				}
				if (cloneOption != JOptionPane.CANCEL_OPTION) {
					boolean ok =
						persistence.cloneProject(
							(String) projectNames.getSelectedItem(),
							newProject.getText());
					if (!ok) {
						JOptionPane.showMessageDialog(
							null,
							"BnProject name already exist... ");
					} else {
						manager.openProject(newProject.getText());
						return true;
					}
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(
				null,
				"System error in clone project");
		}
		return false;
	}

	public void openProject() {
		try {
			Object[] values = persistence.getProjects();
			Object selectedValue =
				JOptionPane.showInputDialog(
					null,
					"Choose BnProject",
					"Graph Editor",
					JOptionPane.INFORMATION_MESSAGE,
					null,
					values,
					values[0]);
			if (selectedValue != null) {
				manager.openProject((String) selectedValue);
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null, "System Error in open project");
		}
	}
	
	public void editNode(String nodeName) {

		String result = null;
		JPanel jp = new JPanel();
		try {
			StrutsNodeValue nl = persistence.getProjectNode(nodeName);
			GridBagLayout gridbag = new GridBagLayout();
			GridBagConstraints c = new GridBagConstraints();
			jp.setLayout(gridbag);

			c.fill = GridBagConstraints.BOTH;
			c.weightx = 1.0;

			jp.add(new JLabel("Deadline:"));
			DateComboBox dcb = new DateComboBox();
			SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
			SimpleDateFormat dateFormat = new SimpleDateFormat("MMM dd,yyyy");
			if (persistence.getDeadline(nodeName) != null)
				dcb.setSelectedItem(
					dateFormat.format(df.parse(nl.getDeadline().toString())));

			dcb.setEditable(true);
			jp.add(dcb);
			gridbag.setConstraints(dcb, c);
			c.gridwidth = GridBagConstraints.REMAINDER;

			c.weightx = 1.0;
			Object[] possibleRoles = persistence.getRoles();
			JComboBox roles = new JComboBox(possibleRoles);
			roles.setSelectedItem(persistence.getRole(nodeName));
			jp.add(new JLabel("Select role ", SwingConstants.LEFT));
			jp.add(roles);
			gridbag.setConstraints(roles, c);

			c.gridwidth = GridBagConstraints.REMAINDER;
			c.weightx = 0.0;

			JTextArea description = new JTextArea(nl.getDescription());
			JScrollPane areaScrollPane = new JScrollPane(description);
			areaScrollPane.setVerticalScrollBarPolicy(
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			areaScrollPane.setPreferredSize(new Dimension(200, 100));

			jp.add(new JLabel("Description", SwingConstants.LEFT));
			jp.add(areaScrollPane);
			gridbag.setConstraints(areaScrollPane, c);

			int option =
				JOptionPane.showConfirmDialog(
					null,
					jp,
					"Edit Activity",
					JOptionPane.OK_CANCEL_OPTION);

			if (option != JOptionPane.CANCEL_OPTION) {
				if (dcb.getSelectedItem() != null) {
					java.util.Date deadline =
						dateFormat.parse((String) dcb.getSelectedItem());

					while (deadline.getTime() <= System.currentTimeMillis()
						&& option != JOptionPane.CANCEL_OPTION) {
						JOptionPane.showMessageDialog(
							null,
							"Deadline is after de current date !!");
						option =
							JOptionPane.showConfirmDialog(
								null,
								jp,
								"Edit Activity",
								JOptionPane.OK_CANCEL_OPTION);
						deadline =
							dateFormat.parse((String) dcb.getSelectedItem());
					}
					persistence.setEditNode(
						nodeName,
						(String) roles.getSelectedItem(),
						description.getText(),
						deadline.getTime());
				} else {
					persistence.setNodeDescription(
						nodeName,
						description.getText());
					persistence.setNodeRole(
						nodeName,
						(String) roles.getSelectedItem());
				}
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(
				null,
				"System error in edit activity: " + e.getMessage());
		}
	}

	public Vector addNodeInterHook() {
		Vector result = new Vector();
		Vector hookTypes = new Vector();
		hookTypes.add(hero.interfaces.Constants.Nd.AFTERSTART);
		hookTypes.add(hero.interfaces.Constants.Nd.BEFORESTART);
		hookTypes.add(hero.interfaces.Constants.Nd.AFTERTERMINATE);
		hookTypes.add(hero.interfaces.Constants.Nd.BEFORETERMINATE);
		hookTypes.add(hero.interfaces.Constants.Nd.CREATE);
		hookTypes.add(hero.interfaces.Constants.Nd.ANTICIPATE);
		hookTypes.add(hero.interfaces.Constants.Nd.EXECUTE);

		JPanel jp = new JPanel();
		JTextField hook = new JTextField("", 10);
		jp.add(new JLabel("Hook Name: ", SwingConstants.LEFT));
		jp.add(hook);

		JComboBox types = new JComboBox(hookTypes);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel("Choose Type ", SwingConstants.LEFT));
		jp.add(types);

		int option =
			JOptionPane.showConfirmDialog(
				null,
				jp,
				"New Hook",
				JOptionPane.OK_CANCEL_OPTION);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((hook.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(
					null,
					hook.getText()
						+ " Hook name is null: Please enter a correct value ");
				option =
					JOptionPane.showConfirmDialog(
						null,
						jp,
						"New Hook",
						JOptionPane.OK_CANCEL_OPTION);
			}
			if (option != JOptionPane.CANCEL_OPTION) {
				result.add(hook.getText());
				result.add((String) types.getSelectedItem());
				String value = null;
				switch (types.getSelectedIndex()) {
					case 0 :
						value = hero.interfaces.Constants.AFTERSTART;
						break;
					case 1 :
						value = hero.interfaces.Constants.BEFORESTART;
						break;
					case 2 :
						value = hero.interfaces.Constants.AFTERTERMINATE;
						break;
					case 3 :
						value = hero.interfaces.Constants.BEFORETERMINATE;
						break;
					case 4 :
						value = hero.interfaces.Constants.CREATE;
						break;
					case 5 :
						value = hero.interfaces.Constants.ANTICIPATE;
						break;
					case 6 :
						value = hero.interfaces.Constants.EXECUTE;
						break;
				}
				result.add(value);
				return (result);
			}
		}
		return (result);
	}

	public String setNodeInterHookValue(String value) {

		String result = null;
		JPanel jp = new JPanel();
		JTextArea hook = new JTextArea(value);
		JScrollPane areaScrollPane = new JScrollPane(hook);
		areaScrollPane.setVerticalScrollBarPolicy(
			JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(350, 250));

		jp.add(new JLabel("Hook Action", SwingConstants.LEFT));
		jp.add(areaScrollPane);

		int option =
			JOptionPane.showConfirmDialog(
				null,
				jp,
				"Hook Action Script",
				JOptionPane.OK_CANCEL_OPTION);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((hook.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(
					null,
					hook.getText()
						+ " Hook name is null: Please enter a correct value ");
				option =
					JOptionPane.showConfirmDialog(
						null,
						jp,
						"Hook Action Script",
						JOptionPane.OK_CANCEL_OPTION);
			}
			if (option != JOptionPane.CANCEL_OPTION)
				result = hook.getText();
		}
		return (result);
	}

	public void addPropertyWindow(String node) {
		JPanel jp = new JPanel();

		JTextField key = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel("Property Key ", SwingConstants.LEFT));
		jp.add(key);

		JTextField value = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel("Property Value ", SwingConstants.LEFT));
		jp.add(value);

		JCheckBox prop = new JCheckBox("Propagate");
		prop.setSelected(true);
		jp.add(prop);

		int option =
			JOptionPane.showConfirmDialog(
				null,
				jp,
				"New Property",
				JOptionPane.OK_CANCEL_OPTION);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((key.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(
					null,
					"Please enter a new property... ");
				option =
					JOptionPane.showConfirmDialog(
						null,
						jp,
						"New Property",
						JOptionPane.OK_CANCEL_OPTION);
			}
			if (option != JOptionPane.CANCEL_OPTION && !prop.isSelected()) {
				try {
					persistence.addNodeProperty(
						node,
						key.getText(),
						value.getText(),
						false);
				} catch (Exception e) {
					JOptionPane.showMessageDialog(
						null,
						"Add Property error. Property already exist");
				}
			} else if (
				option != JOptionPane.CANCEL_OPTION && prop.isSelected()) {
				try {
					persistence.addNodeProperty(
						node,
						key.getText(),
						value.getText(),
						true);
				} catch (Exception e) {
					JOptionPane.showMessageDialog(
						null,
						"Add Property error. Property already exist");
				}
			}
		}
	}

	public Vector addNode() {
		Vector result = new Vector();
		try {
			JPanel jp = new JPanel();
			Vector nodeTypes = new Vector();
			nodeTypes.add("AND JOIN");
			nodeTypes.add("OR JOIN");
			nodeTypes.add("AND JOIN AUTO");
			nodeTypes.add("OR JOIN AUTO");

			JTextField nodeName = new JTextField("", 10);
			jp.add(new JLabel("BnNode Name: ", SwingConstants.LEFT));
			jp.add(nodeName);

			JComboBox types = new JComboBox(nodeTypes);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel("Choose Type ", SwingConstants.LEFT));
			jp.add(types);
			int option =
				JOptionPane.showConfirmDialog(
					null,
					jp,
					"New BnNode",
					JOptionPane.OK_CANCEL_OPTION);
			if (option != JOptionPane.CANCEL_OPTION) {
				while ((persistence.containsNode(nodeName.getText())
					|| (nodeName.getText()).equals(""))
					&& option != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(
						null,
						nodeName.getText()
							+ " BnNode already exist or null: Please enter new value ");
					option =
						JOptionPane.showConfirmDialog(
							null,
							jp,
							"New BnNode",
							JOptionPane.OK_CANCEL_OPTION);
				}
				if (option != JOptionPane.CANCEL_OPTION) {
					result.add(nodeName.getText());
					result.add((String) types.getSelectedItem());
					return (result);

				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null, "System error in add node");
		}
		return (result);
	}

	public String setEdgeCondition() {
		String result = null;

		JPanel jp = new JPanel();
		JTextField condition = new JTextField("", 30);
		jp.add(new JLabel("BnEdge Condition: ", SwingConstants.LEFT));
		jp.add(condition);

		int option =
			JOptionPane.showConfirmDialog(
				null,
				jp,
				"Set BnEdge Condition",
				JOptionPane.OK_CANCEL_OPTION);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((condition.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(
					null,
					condition.getText()
						+ " Condition is null: Please enter a correct value ");
				option =
					JOptionPane.showConfirmDialog(
						null,
						jp,
						"Set BnEdge Condition",
						JOptionPane.OK_CANCEL_OPTION);
			}
			if (option != JOptionPane.CANCEL_OPTION) {
				result = condition.getText();
				return (result);

			}
		}
		return (result);
	}

	public void changeRoleWindow(String node) {
		try {
			Object[] possibleRoles = persistence.getRoles();

			JPanel jp = new JPanel();

			JComboBox roles = new JComboBox(possibleRoles);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel("Select role ", SwingConstants.LEFT));
			jp.add(roles);

			int option =
				JOptionPane.showConfirmDialog(
					null,
					jp,
					"Change role",
					JOptionPane.OK_CANCEL_OPTION);
			if (option != JOptionPane.CANCEL_OPTION) {
				persistence.setNodeRole(node, (String) roles.getSelectedItem());
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private boolean contains(Object[] data, String elem) {
		for (int i = 0; i < data.length; i++) {
			if (((String) data[i]).equalsIgnoreCase(elem))
				return true;
		}
		return false;
	}

	public void newUser() {
		try {
			Object[] usersIn = persistence.getUsersInProject();
			Object[] allUsers = persistence.getAllUsers();
			int size = allUsers.length - usersIn.length;

			if (size == 0)
				JOptionPane.showMessageDialog(null, "Not more users...");
			else {
				Object[] possibleUsers = new Object[size];
				int j = 0;
				for (int i = 0; i < allUsers.length; i++) {
					if (!contains(usersIn, (String) allUsers[i])) {
						possibleUsers[j] = allUsers[i];
						j++;
					}
				}

				JPanel jp = new JPanel();

				JComboBox users = new JComboBox(possibleUsers);
				jp.setLayout(new GridLayout(0, 2));
				jp.add(new JLabel("Select user ", SwingConstants.LEFT));
				jp.add(users);

				int option =
					JOptionPane.showConfirmDialog(
						null,
						jp,
						"New BnUser",
						JOptionPane.OK_CANCEL_OPTION);

				if (option != JOptionPane.CANCEL_OPTION) {
					persistence.addUser((String) users.getSelectedItem());
				}
			}
		} catch (Exception e) {
		}
	}

	public void newRole() {
		JPanel jp = new JPanel();

		JTextField roleName = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel("BnRole Name ", SwingConstants.LEFT));
		jp.add(roleName);

		JTextField description = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel("Description ", SwingConstants.LEFT));
		jp.add(description);

		int option =
			JOptionPane.showConfirmDialog(
				null,
				jp,
				"New BnRole",
				JOptionPane.OK_CANCEL_OPTION);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((roleName.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(
					null,
					"Please enter roleName value... ");
				option =
					JOptionPane.showConfirmDialog(
						null,
						jp,
						"New BnRole",
						JOptionPane.OK_CANCEL_OPTION);
			}
			if (option != JOptionPane.CANCEL_OPTION) {
				try {
					persistence.addRole(
						roleName.getText(),
						description.getText());
				} catch (Exception e) {
					JOptionPane.showMessageDialog(
						null,
						"Add BnRole error. RoleName already exist");
				}
			}
		}
	}

	public void addUserToRole() {
		try {
			JPanel jp = new JPanel();

			Object[] possibleUsers = persistence.getUsersInProject();

			JComboBox users = new JComboBox(possibleUsers);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel("Select user ", SwingConstants.LEFT));
			jp.add(users);

			Object[] possibleRoles = persistence.getRoles();

			JComboBox roles = new JComboBox(possibleRoles);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel("Select role ", SwingConstants.LEFT));
			jp.add(roles);
			int option =
				JOptionPane.showConfirmDialog(
					null,
					jp,
					"Add user role",
					JOptionPane.OK_CANCEL_OPTION);

			if (option != JOptionPane.CANCEL_OPTION) {
				try {
					persistence.setUserRole(
						(String) users.getSelectedItem(),
						(String) roles.getSelectedItem());
				} catch (Exception exx) {
					JOptionPane.showMessageDialog(
						null,
						"Add user role error. BnUser role already exist");
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			JOptionPane.showMessageDialog(null, "Add user role Exception");
		}
	}

	public void usersInProject() {
		try {
			JPanel jp = new JPanel();

			Object[] users = persistence.getUsersInProject();
			String text = "<html><table border=1><tr><th>BnUser / Roles</th>";
			Object[] nameRoles = persistence.getRoles();
			for (int i = 0; i < nameRoles.length; i++) {
				text = text + "<th>" + (String) nameRoles[i] + "</th>";
			}

			for (int j = 0; j < users.length; j++) {

				text =
					text
						+ "<tr bgcolor=white><td>"
						+ (String) users[j]
						+ "</td>";

				for (int i = 0; i < nameRoles.length; i++) {
					if (persistence
						.isInRole((String) users[j], (String) nameRoles[i])) {
						text = text + "<td align=center> X </td>";
					} else {
						text = text + "<td></td>";
					}
				}
				text = text + "</tr>";
			}
			text = text + "</table></html>";
			JLabel jText = new JLabel(text);
			jp.add(jText);
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

			JScrollPane scroll = new JScrollPane(jp);
			scroll.setMaximumSize(
				new Dimension(screenSize.width / 2, screenSize.height / 2));
			JFrame fr = new JFrame("Users In BnProject ");
			fr.getContentPane().add(scroll, BorderLayout.CENTER);
			fr.pack();

			Dimension jpDim = scroll.getPreferredSize();
			fr.setLocation(
				screenSize.width / 2 - (jpDim.width / 2),
				screenSize.height / 2 - (jpDim.height / 2));
			fr.setResizable(true);
			fr.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
			JOptionPane.showMessageDialog(null, "List user-role Exception");
		}
	}

} // WFWindowManager
