package hero.client.manager;

/*
*
* JProjectList.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.Constants;
import hero.util.EventConstants;
import hero.util.BonitaClient;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class JProjectList
	extends JPanel
	implements PropertyChangeListener, Constants.Nd, EventConstants, MouseListener {

	private JList projectList = null;
	private DefaultListModel model;
	private JScrollPane jsppl;
	private MListener ml;
	public final static String SELECTED = "selected";
	public final static String PROJECTCLOSE = "close";
	public Hashtable projects = new Hashtable();
	private hero.client.grapheditor.Frame frame;
	private BonitaClient soapclient;
	private Collection actualProjects;

	public JProjectList(BonitaClient soapclient,MListener ml,Collection projects) {
		try {
			this.actualProjects = projects;
			ml.addEventProjectListener(this);
			model = new DefaultListModel();
			projectList = new JList(model);
			projectList.setCellRenderer(new ManagerCellRenderer());

			jsppl = new JScrollPane(projectList);
			this.setLayout(new BorderLayout());
			this.add(new JLabel("BnProject List"), BorderLayout.NORTH);
			this.add(jsppl, BorderLayout.CENTER);
			projectList.addMouseListener(this);

			this.soapclient = soapclient;
			Iterator i = projects.iterator();

			while (i.hasNext()) {
				String p = (String) i.next();
				ListItem li = new ListItem(Color.white, p);
				model.addElement(li);
			}

		} catch (Exception e) {
		}
	}
	
	public void newProject() {
			String projectName = JOptionPane.showInputDialog(null, "BnProject Name: ", "New project", JOptionPane.INFORMATION_MESSAGE);
			while (projectName != null && projectName.equals("")) {
				JOptionPane.showMessageDialog(null, "Please enter project name");
				projectName = JOptionPane.showInputDialog(null, "BnProject Name: ", "New BnProject", JOptionPane.INFORMATION_MESSAGE);
			}
			if (projectName != null) {
				try {
					if (exists(projectName)) {
						JOptionPane.showMessageDialog(null, "BnProject already exist or not user permission... ");
					} else {				
						soapclient.createProject(projectName);
						//this.actualProjects = soapclient.getProjects();
					}
				} catch (Exception ex) {
					JOptionPane.showMessageDialog(null, "BnProject already exist or not user permission... ");
				}
			}
		}
		
		private boolean exists(String project) {
			try {
				Object[] elems = this.actualProjects.toArray();
				for (int i = 0; i < elems.length; i++) {
					if (((String) elems[i]).equalsIgnoreCase(project))
						return true;
				}
				return false;
			} catch (Exception e) {
				e.printStackTrace();
			}
			return true;
		}


	public void mouseReleased(MouseEvent e) {
		try {
			if (!projectList.isSelectionEmpty()) {
				if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK)
					!= 0) {
					JPopupMenu menu = new JPopupMenu();
					PopupMenu(menu);

					Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
					Dimension size = menu.getPreferredSize();

					// Flip along screen

					int x = e.getX();
					int y = e.getY();

					menu.show(this,e.getX()	- (int) jsppl.getViewport().getViewPosition().getX(),e.getY()- (int) jsppl.getViewport().getViewPosition().getY());

				} else if (e.getClickCount() == 1) {
					String pl =((ListItem) projectList.getSelectedValue()).getValue();
					firePropertyChange(SELECTED, "", pl);
				} else if (e.getClickCount() == 2) {
					try {

						if (!projects.containsKey(((ListItem) projectList.getSelectedValue()).getValue())) {
							frame =	new hero.client.grapheditor.Frame(((ListItem) projectList.getSelectedValue()).getValue(),soapclient);
							frame.setSize(new Dimension(500, 400));
							frame.setVisible(true);
							projects.put(((ListItem) projectList.getSelectedValue()).getValue(),frame);
							frame.addPropertyChangeListener(PROJECTCLOSE, this);
						} else {
							frame =(hero.client.grapheditor.Frame) projects.get(((ListItem) projectList.getSelectedValue()).getValue());
							frame.requestFocus();
						}
					} catch (Exception ce) {
						JOptionPane.showMessageDialog(null,"This user cannot modify "+ ((ListItem) projectList.getSelectedValue()).getValue()+ " project");
					}
				}
			}
		} catch (Exception e1){
			JOptionPane.showMessageDialog(null,"Internal error in project list...");
		}
	}

	public void PopupMenu(JPopupMenu menu) {
		JMenuItem mi;
		ClassLoader cl = this.getClass().getClassLoader();

		mi = (JMenuItem) menu.add(new JMenuItem(" Clone project"));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cloneProject(
					((ListItem) projectList.getSelectedValue()).getValue());
			}
		});

		mi = (JMenuItem) menu.add(new JMenuItem(" Details..."));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")
						+ "/bonita/protected/Action.jsp?projectname="
						+ ((ListItem) projectList.getSelectedValue()).getValue());
			}
		});

		mi = (JMenuItem) menu.add(new JMenuItem(" Delete Project"));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteProject(
					((ListItem) projectList.getSelectedValue()).getValue());
			}
		});
	}

	public void deleteProject(String project) {
		try {
			int option =
				JOptionPane.showConfirmDialog(null,"This operation will delete this Workflow project !!");
			if (option == JOptionPane.OK_OPTION) {
				if (soapclient.deleteProject(project) == true)
					JOptionPane.showMessageDialog(null,"Project " + project + " removed successfully");
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,e.getMessage());
		}
	}

	public void cloneProject(String project) {
		try {
			String newProject =	JOptionPane.showInputDialog(null,"BnProject Name: ","Clone BnProject",JOptionPane.INFORMATION_MESSAGE);

			while (newProject != null && newProject.equals("")) {
				JOptionPane.showMessageDialog(null,"Please enter the name of the new project... ");
				newProject =JOptionPane.showInputDialog(null,"BnProject Name: ","Clone BnProject",JOptionPane.INFORMATION_MESSAGE);
			}
			if (newProject != null)
				soapclient.cloneProject(project, newProject);

		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,"BnProject name already exist... ");
		}
	}

	public void changeEvent(Object[] e, String projectName) {
		model.clear();
		this.actualProjects.remove(projectName);
		e = actualProjects.toArray(); 
	    int i = 0;
		for (i = 0; i < e.length; i++) {
			ListItem li = new ListItem(Color.white, e[i].toString());
			model.addElement(li);
		}
	}
	public void addElement(String projectName) {
		if (!exists(projectName)){
		ListItem li = new ListItem(Color.white, projectName);
		model.addElement(li);
		actualProjects.add(projectName);
		}
	}

	public void propertyChange(PropertyChangeEvent e) {
		try {
			if (e.getPropertyName().equals(PROJECTCLOSE)) {
				projects.remove(e.getNewValue());
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	// Rest of mouse listener is empty
	public void mousePressed(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
	}

}
