/*
*
* Hook.java - 
* Copyright (C) 2003 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.hook;

import hero.interfaces.BnNodeLocal;
import hero.util.HeroException;
import hero.util.HeroHookException;
import java.io.Serializable;

public abstract class Hook implements Serializable{


    public static final int JAVA=0;
    public static final int JYTHON=1;
    public static final int EXTERNAL=2;
    public static final int CLIENT =3;
    public static final int TCL =4;
    public static final int BEANSHELL =5;
    public static final int BSINTERACTIVE =6;

    private String name;
    private String event;
    private int type;

    public static Hook make(String name, String event, int type) throws HeroException {
	if (type==JAVA) {return new JavaHook(name,event,type);}
	//	if (type==JYTHON) {return new JythonHook(name,event,type);}
	//	if (type==EXTERNAL) {return new ExternalHook(name,event,type);}
	//	if (type==CLIENT) {return new ClientHook(name,event,type);}
		if (type==TCL) {return new TclHook(name,event,type);}
		if (type==BEANSHELL) {return new BeanShellHook(name,event,type);}
		if (type==BSINTERACTIVE) {return new InteractiveBSHook(name,event,type);}
	throw new HeroException("Wrong Hook Type "+type);
    }

    protected Hook(String name, String event, int type) {
	this.name=name;
	this.event=event;
	this.type=type;
    }

    public String getName() {return this.name;}
    public void setName(String name) {this.name=name;}

    public int getType() {return this.type;}
    public void setType(int type) {this.type=type;}

    public String getEvent() {return this.event;}
    public void setEvent(String event) {this.event=event;}

    public String toXML() {
	String result=new String();
	result="<hook name=\""+this.getName()+
	    "\" type=\""+this.getType()+
	    "\" event=\""+this.getEvent()+"\"/>";
	return result;
    }

    public abstract void execute(Object bean,String eventName, BnNodeLocal node) throws HeroHookException;

}
