/*
*
* BeanShellHook.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.hook;

import hero.interfaces.BnNodeInterHookLocal;
import hero.interfaces.BnNodeLocal;
import hero.interfaces.BnNodePropertyLocal;
import hero.interfaces.BnProjectInterHookLocal;
import hero.interfaces.BnProjectLocal;
import hero.util.HeroHookException;

import java.util.Collection;
import java.util.Iterator;

import bsh.Interpreter;

public class InteractiveBSHook extends Hook {

    public InteractiveBSHook(String name, String event, int type) {
	super(name,event,type);
    }

    public void execute(Object bean,String eventName,BnNodeLocal node) throws HeroHookException {
	try {
	    String value = null;

	    Collection hooks=node.getBnInterHooks();
	    for (Iterator ih=hooks.iterator();ih.hasNext();) {
		BnNodeInterHookLocal hk=(BnNodeInterHookLocal)ih.next();
		if(hk.getName().equals(super.getName()))	      
		    value = hk.getScript();		
	    }
	    if (value == null)
	    {
		BnProjectLocal pl = node.getBnProject();
		Collection phooks=pl.getBnInterHooks();
		for (Iterator ih=phooks.iterator();ih.hasNext();) {
		    BnProjectInterHookLocal phk=(BnProjectInterHookLocal)ih.next();
		    if(phk.getName().equals(super.getName()))
			value = phk.getScript();
		}		
	    }

	    Interpreter i = new Interpreter();
	    i.set("node",node);
	    i.set("bean",bean);

	    // BnNode properties mapping

	    Collection prop = node.getBnProperties();
	    for (Iterator props=prop.iterator();props.hasNext();) {
		BnNodePropertyLocal pl=(BnNodePropertyLocal)props.next();
		i.set(pl.getTheKey(),pl.getTheValue());
	    }

	    i.eval(value);
	    i.eval(eventName+"(bean,node)");
	    
	} catch (Exception t) {	    
	    throw new HeroHookException("Cannot execute beanshell hook "+t.getMessage());
	}
    }

}
