/*
*
* JMSEventsException.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


package hero.util;   
import java.util.*;
import java.io.*;

public class JMSEvents implements java.io.Serializable, EventConstants
{
    public JMSEvents(){}

    public void sendNodeEvent(String event, String projectName, String nodeName, int type, int state, String userName)
    {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);
	  
	  outlog.println("Event: "+event+", BnProject: "+projectName+", NodeName: "+ nodeName+", Type: "+type+", State: "+state+", UserName: "+userName);
  
	  outlog.close();
	}catch (Exception e){e.printStackTrace();}
	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(NODENAME,nodeName);
	    evt.put(NODETYPE,(new Integer(type)).toString());
	    evt.put(NODESTATE,(new Integer(state)).toString());
	    evt.put(USERNAME,userName);
	    jms.send(evt, NODE);

	}catch(Exception e){e.printStackTrace();}
    }
    
    public void sendEdgeEvent(String event, String projectName, String edgeName, String nodeIn, String nodeOut, String userName)
    {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);

	  outlog.println("Event: "+event+", BnProject: "+projectName+", EdgeName: "+ edgeName+", NodeIn: "+nodeIn+", NodeOut: "+nodeOut+", UserName: "+userName);

	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(EDGENAME,edgeName);
	    evt.put(NODEIN,nodeIn);
	    evt.put(NODEOUT,nodeOut);
	    evt.put(USERNAME,userName);
	    jms.send(evt,EDGE);
	}catch(Exception e){e.printStackTrace();}
    }

    public void sendProjectEvent(String event, String projectName)
    {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);

	  outlog.println("Event: "+event+", BnProject: "+projectName);
	  
	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    jms.send(evt,PROJECT);

	}catch(Exception e){e.printStackTrace();}
    }


    public void sendProjectEvent(String event, String projectName, String userName)
    {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);

	  outlog.println("Event: "+event+", BnProject: "+projectName);
	  
	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(USERNAME,userName);
	    jms.send(evt,PROJECT);

	}catch(Exception e){e.printStackTrace();}
    }

    public void sendProjectEvent(String event, String projectName, String nodeName, String userName)
    {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);
	  
	  outlog.println("Event: "+event+", BnProject: "+projectName+", NodeName: "+ nodeName+", UserName: "+ userName);
	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(NODENAME,nodeName);
	    evt.put(USERNAME,userName);
	    jms.send(evt,PROJECT);
	}catch(Exception e){e.printStackTrace();}
    }

    public void sendUserEvent(String event, String projectName, String userName) {

	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);

	  outlog.println("Event: "+event+", BnProject: "+projectName+", UserName: "+userName);
	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(USERNAME,userName);
	    jms.send(evt, USER);

	}catch(Exception e){e.printStackTrace();}
    }

    public void sendRoleEvent(String event, String projectName, String roleName) {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);
	  
	  outlog.println("Event: "+event+", BnProject: "+projectName+", RoleName: "+ roleName);

	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(ROLENAME,roleName);
	    jms.send(evt, ROLE);
	}catch(Exception e){e.printStackTrace();}
    }
	
    public void sendUserRoleEvent(String event, String projectName, String userName, String roleName) {
	try {
	  FileOutputStream out = new FileOutputStream(LOG,true);
	  PrintWriter outlog = new PrintWriter(out);
	  
	  outlog.println("Event: "+event+", BnProject: "+projectName+", UserName: "+ userName+", RoleName: "+roleName);

	  outlog.close();
	}catch (Exception e){e.printStackTrace();}

	try {
	    JMSServices jms = JMSServices.getInstance();
	    Hashtable evt = new Hashtable();
	    evt.put(EVENT,event);
	    evt.put(PROJECTNAME,projectName);
	    evt.put(USERNAME,userName);
	    evt.put(ROLENAME,roleName);
	    jms.send(evt, USERROLE);

	}catch(Exception e){e.printStackTrace();}
    }
   
}
    
